/// <reference types="node" />
import * as http from "http";
import { IncomingMessage, ServerResponse } from "http";
import { IBody } from "./body";
import { Methods } from "./methods";
export interface ICtxRequest extends IncomingMessage {
    body: any;
}
export interface ICtx {
    params: {
        [key: string]: string;
    };
    readonly req: ICtxRequest;
    readonly res: ServerResponse;
    matches?: RegExpExecArray[];
    path: string;
    data: ICtxData;
    method: Methods;
    providers: ICtxProviders;
    body?: IBody;
    readonly query: any;
    statusCode?: number;
    readonly workerId?: number;
    readonly requestId?: string;
    error?: Error;
}
export interface ICtxData {
    [key: string]: any;
}
export interface ICtxProviders {
    [key: string]: any;
}
export interface ICreateCtx {
    path?: string;
    query?: any;
    requestId?: string;
    workerId?: number;
    method?: string;
    providers?: ICtxProviders;
    res: http.ServerResponse;
    req: ICtxRequest;
}
