import { ErrorHandler, RouteHandler } from "./handler";
import { Handler, Middleware } from "./index";
import { Methods } from "./methods";
import { IRouteOptions } from "./route";
declare type RouteAdder = (path: string, handler: RouteHandler, options?: IRouteOptions) => Router;
declare type RouterWithMiddlewares = [Router | null, Middleware | Middleware[]];
export declare class Router {
    errorHandler: ErrorHandler | undefined;
    get: RouteAdder;
    post: RouteAdder;
    delete: RouteAdder;
    put: RouteAdder;
    patch: RouteAdder;
    private routes;
    private middlewares;
    child: (path: string, handler?: Router | RouterWithMiddlewares | undefined, options?: IRouteOptions | undefined) => Router;
    route: (method: Methods | Methods[] | undefined, path: string, handler: RouteHandler, options?: IRouteOptions | undefined) => this;
    any: (path: string, handler: RouteHandler, options?: IRouteOptions | undefined) => this;
    middleware: (middleware: Middleware | Middleware[]) => this;
    handle: Handler;
}
export {};
